﻿// Goldie: GOLD Engine for D
// Written in the D programming language.

/++
$(WEB http://www.dsource.org/projects/goldie, Goldie Homepage)

Goldie is licensed under The zlib/libpng License. See LICENSE.txt for details.

Author:
$(WEB www.semitwist.com, Nick Sabalausky)

This has been tested to work with:
  - DMD 1.056 / Tango 0.99.9 / Rebuild 0.76
  - DMD 1.056 / Tango 0.99.9 / xfBuild 0.4

In SVN comments:
(B): Includes breaking changes
(NB): No Breaking changes
However, even a (NB) revision might still require
static languages to be re-generated.
+/

module /+S:PACKAGE+/goldie/+E:PACKAGE+/.all;

/+P:SET_VERSION+/

/+S:REM+/
public import goldie.base;
public import goldie.goldie;
public import goldie.exception;
public import goldie.lang;
public import goldie.lexer;
public import goldie.parser;
public import goldie.token;
/+E:REM+/

version(GoldieStaticLang)
{
	public import /+P:PACKAGE+/DUMMY.lang;
	public import /+P:PACKAGE+/DUMMY.lexer;
	public import /+P:PACKAGE+/DUMMY.parser;
	public import /+P:PACKAGE+/DUMMY.token;
}

// Note: The goldie.file module is not imported here because
// the vast majority of apps will not need to use it directly.

//TODO? Make sanity checks execute in debug-mode only
//TODO? Sanitize usages of terminology like "symbol", "token name" etc. in class Token
//TODO: Make modification of calculator* that builds an AST and saves as XML instead of calculating.
//TODO: Add StringOf to Token_{languageName}!() and Token
//TODO: Fix: Lexer_{languageName}.process() takes a Language as a parameter (Also 'Parser_').
//TODO: Check on incorrect line/col reported upon lexer error that spans
//      multiple lines and ends with EOL.
//TODO? Add skeleton "process" func in generated static-style.
